package com.zswl.cloud.springBtach.server.core.controller;

import com.eeext.openapi.entity.RechargeOrderReq;
import com.eeext.openapi.entity.RechargeProductResp;
import com.github.microservice.auth.client.constant.AuthConstant;
import com.github.microservice.auth.client.content.ResultContent;
import com.github.microservice.auth.security.annotations.ResourceAuth;
import com.github.microservice.auth.security.type.AuthType;
import com.zhongshu.payment.client.aop.Code;
import com.zhongshu.payment.client.model.order.v2.CreatOrderResultModel;
import com.zswl.cloud.springBatch.client.model.video2.RechargeRequest;
import com.zswl.cloud.springBtach.server.core.service.impl.Video2ServiceImpl;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@Log4j2
@RestController
@RequestMapping("video2")
public class Video2Controller {


    @Autowired
    private Video2ServiceImpl video2Service;

    @ApiOperation("获取商品列表接口")
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    @RequestMapping(value = "rechargeProduct", method = RequestMethod.GET)
    ResultContent<RechargeProductResp> rechargeProduct() {
        return video2Service.rechargeProduct();
    }

    @ApiOperation("创建视频会员订单")
    @Code
    @ResourceAuth(value = AuthConstant.User, type = AuthType.User)
    @RequestMapping(value = "creatOrder", method = RequestMethod.POST)
    ResultContent<CreatOrderResultModel> rechargeProduct(@RequestBody RechargeRequest rechargeOrderReq) {
        return video2Service.creatOrder(rechargeOrderReq);
    }
}
