package com.zswl.cloud.springBtach.server.core.publish;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.eeext.openapi.entity.RechargeProductResp;
import com.github.microservice.productcenter.client.model.LocationModel;
import com.github.microservice.productcenter.client.model.ProductPushModel;
import com.github.microservice.productcenter.client.model.ProductTriggerTaskModel;
import com.github.microservice.productcenter.client.publish.ProductPublish;
import com.github.microservice.productcenter.client.service.ProductPushService;
import com.github.microservice.productcenter.client.stream.ProductCenterStream;
import com.github.microservice.productcenter.client.type.ProductType;
import com.github.microservice.productcenter.client.type.RegionType;
import com.zswl.cloud.springBtach.server.core.api.video2.Video2Api;
import com.zswl.cloud.springBtach.server.core.api.ypp.YppApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

@Slf4j
@Component
public class Video2Publish implements ProductPublish {

    @Autowired
    private ProductCenterStream productCenterStream;

    @Autowired
    private Video2Api video2Api;

    @Override
    public String regionCode() {
        return null;
    }

    @Override
    public Collection<RegionType> regionType() {
        return Set.of(RegionType.City);
    }

    @Override
    public Collection<ProductType> productTypes() {
        return Set.of(
                ProductType.Recharge
        );
    }


    @Override
    public void trigger(ProductPushService updateService, ProductTriggerTaskModel productTriggerTask) {
        RechargeProductResp rechargeProductResp = video2Api.rechargeProduct();

        rechargeProductResp.getProducts().forEach(it -> {
            try {
                BigDecimal bigDecimal = new BigDecimal(it.getChannelPrice());
                BigDecimal multiply = bigDecimal.multiply(BigDecimal.valueOf(100));
                productCenterStream.send(List.of(
                        ProductPushModel.builder()
                                .regionCode(productTriggerTask.getRegion().getCode())
                                .parkId(productTriggerTask.getRegion().getParentId())
                                .pid(String.valueOf(it.getProductId()))
                                .productType(ProductType.Recharge)
                                .title(it.getItemName())
                                .salePrice(multiply.longValue())
                                .meta(Map.of("goods", it))
                                .expireTimeSecond(60 * 60 * 24)
                                .build()
                ));
            } catch (Exception e) {
                e.printStackTrace();
            }

        });


    }
}
